//Matthew Sauve's firework ignitor Program

#include <SoftwareSerial.h>
#include <EEPROM.h>
#include <MsTimer2.h>

#define rxPin 4
#define txPin 14
SoftwareSerial mySerial =  SoftwareSerial(rxPin, txPin);  //set the pins used by the LCD (the rx pin doesnt matter)


int v = 0;
int fire1 = 2;
int fire2 = 3;
int fire3 = 4;
int fire4 = 5;
int fire5 = 6;
int fire6 = 7;
int fire7 = 8;
int fire8 = 9;
int led = 13;          //LED for push button
int button = 10;
int lbutton;
int t1f = 0;
int t2f = 0;
int t3f = 0;
int t4f = 0;
int t5f = 0;
int t6f = 0;
int t7f = 0;
int t8f = 0;
int d1 = 0;
int d2 = 0;
int d3 = 0;
int d4 = 0;
int d5 = 0;
int d6 = 0;
int d7 = 0;
int d8 = 0;
int load = 0;
boolean upload = true;
boolean ok = true;

void setup()
{
  Serial.begin(9600);
  MsTimer2::set(100, LCD); 
  MsTimer2::start();
  
     pinMode(txPin, OUTPUT);
   mySerial.begin(9600);      // set baud rate of LCD

   mySerial.print("?G216");   // set display geometry,  2 x 16 characters in this case
   delay(100);                // pause to allow LCD EEPROM to program
   
   mySerial.print("?BFF");    // set backlight to ff hex, maximum brightness
   delay(100);                // pause to allow LCD EEPROM to program
  
  t1f = EEPROM.read(1);       //Retrieve the saved values
  t2f = EEPROM.read(2);
  t3f = EEPROM.read(3);
  t4f = EEPROM.read(4);
  t5f = EEPROM.read(5);
  t6f = EEPROM.read(6);
  t7f = EEPROM.read(7);
  t8f = EEPROM.read(8);
  d1 = EEPROM.read(9)*1000;
  d2 = EEPROM.read(10)*1000;
  d3 = EEPROM.read(11)*1000;
  d4 = EEPROM.read(12)*1000;
  d5 = EEPROM.read(13)*1000;
  d6 = EEPROM.read(14)*1000;
  d7 = EEPROM.read(15)*1000;
  d8 = EEPROM.read(16)*1000;
  
  pinMode(fire1,OUTPUT);
  pinMode(fire2,OUTPUT);
  pinMode(fire3,OUTPUT);
  pinMode(fire4,OUTPUT);
  pinMode(fire5,OUTPUT);
  pinMode(fire6,OUTPUT);
  pinMode(fire7,OUTPUT);
  pinMode(fire8,OUTPUT);
  pinMode(led, OUTPUT);
  pinMode(button, INPUT);
  digitalWrite(led, HIGH);
}

void loop()
{
    if(Serial.available()&&upload==true)
    {
    char ch = Serial.read();

    switch(ch) {              //Handle the incoming serial messages 
      case 's':
      ok = false;
      if(load == 0)
      mySerial.print("?f");
      load = 1;
      mySerial.print("?x03"); 
      mySerial.print("LOADING...");
      MsTimer2::stop();
      break;
      
      case '0'...'9':
      v = v * 10 + ch - '0';
      break;
      
      case 'a':
      t1f = v;
      v=0;
      break;
      
      case 'b':
      t2f = v;
      v=0;
      break;
      
      case 'c':
      t3f = v;
      v=0;
      break;
      
      case 'd':
      t4f = v;
      v=0;
      break;
      
      case 'e':
      t5f = v;
      v=0;
      break;
      
      case 'f':
      t6f = v;
      v=0;
      break;
      
      case 'g':
      t7f = v;
      v=0;
      break;
      
      case 'h':
      t8f = v;
      v=0;
      break;
      
      case 'l':
      d1 = v;
      v=0;
      break;
      
      case 'm':
      d2 = v;
      v=0;
      break;
      
      case 'n':
      d3 = v;
      v=0;
      break;
      
      case 'o':
      d4 = v;
      v=0;
      break;
      
      case 'p':
      d5 = v;
      v=0;
      break;
      
      case 'q':
      d6 = v;
      v=0;
      break;
      
      case 'r':
      d7 = v;
      v=0;
      break;
      
      case 't':
      d8 = v;
      v=0;
      break;
      
      case 'M':
      //Message();
      break;
      
      case 'z':                     //Save all of the data when the message ends
      for(int i = 0; i < 512; i++)
       EEPROM.write(i, 0);
      EEPROM.write(1,t1f);
      delay(62);
      EEPROM.write(2,t2f);
      delay(62);
      EEPROM.write(3,t3f);
      delay(62);
      EEPROM.write(4,t4f);
      delay(62);
      EEPROM.write(5,t5f);
      delay(62);
      EEPROM.write(6,t6f);
      delay(62);
      EEPROM.write(7,t7f);
      delay(62);
      EEPROM.write(8,t8f);
      delay(62);
      EEPROM.write(9, d1/1000);
      delay(62);
      EEPROM.write(10,d2/1000);
      delay(62);
      EEPROM.write(11,d3/1000);
      delay(62);
      EEPROM.write(12,d4/1000);
      delay(62);
      EEPROM.write(13,d5/1000);
      delay(62);
      EEPROM.write(14,d6/1000);
      delay(62);
      EEPROM.write(15,d7/1000);
      delay(62);
      EEPROM.write(16,d8/1000);
      ok = true;
      MsTimer2::start();
      break;
    }

    }
    if(ok==true&&upload==true)      //Check if the arm button was pushed
    {
      if(digitalRead(button) == HIGH && lbutton == LOW)
     {
      upload  = false;
      mySerial.print("?f");
     }
     lbutton = digitalRead(button);
    }
    
    if(ok==true&&upload==false)
    {
     if(digitalRead(button) == HIGH && lbutton == LOW)    //Check if the fire button was pushed
     {
      MsTimer2::stop();           //Stop updating the LCD
      mySerial.print("?f");
      mySerial.print("?f?x06Fire!");
      
      if(t1f>0)              //This part starts to turn the numbers revieved into ports needed to be fired. The division and subtraction is to separate the different numbers out like 3 out of 85431
        {
          delay(d1);
          
          if((t1f / 10000000) > 0)
           {
       check(t1f / 1000);
           }
          if((t1f / 1000000)-(t1f / 10000000*10) > 0)
           {
       check((t1f / 1000000)-(t1f / 10000000*10));
           }
          if((t1f / 100000)-(t1f / 1000000*10) > 0)
           {
       check((t1f / 1000010)-(t1f / 1000000*10));
           }
          if((t1f / 10000)-(t1f / 100000*10) > 0)
           {
       check((t1f / 10000)-(t1f / 100000*10));
           }
          if((t1f / 1000)-(t1f / 10000*10) > 0)
           {
       check((t1f / 1000)-(t1f / 10000*10));
           }
          if((t1f / 100)-(t1f / 1000*10) > 0)
           {
       check((t1f / 100)-(t1f / 1000*10));
           }
          if((t1f / 10)-(t1f / 100*10) > 0)
           {
       check((t1f / 10)-(t1f / 100*10));
           }
          if((t1f)-(t1f / 10*10) > 0)
           {
       check((t1f)-(t1f / 10*10));
           }
         }
        
      if(t2f>0)
        {
          delay(d2);
          off();
          
          if(t2f / 10000000 > 0)
           {
       check(t2f / 10000000);
           }
          if((t2f / 1000000)-(t2f / 10000000*10) > 0)
           {
       check((t2f / 1000000)-(t2f / 10000000*10));
           }
          if((t2f / 100000)-(t2f / 1000000*10) > 0)
           {
       check((t2f / 100000)-(t2f / 1000000*10));
           }
          if((t2f / 10000)-(t2f / 100000*10) > 0)
           {
       check((t2f / 10000)-(t2f / 100000*10));
           }
          if((t2f / 1000)-(t2f / 10000*10) > 0)
           {
       check((t2f / 1000)-(t2f / 10000*10));
           }
          if((t2f / 100)-(t2f / 1000*10) > 0)
           {
       check((t2f / 100)-(t2f / 1000*10));
           }
          if((t2f / 10)-(t2f / 100*10) > 0)
           {
       check((t2f / 10)-(t2f / 100*10));
           }
          if((t2f)-(t2f / 10*10) > 0)
           {
       check((t2f)-(t2f / 10*10));
           }
         }
        
      if(t3f>0)
        {
          delay(d3);
          off();
          
          if(t3f / 10000000 > 0)
           {
       check(t3f / 1000);
           }
          if((t3f / 1000000)-(t3f / 10000000*10) > 0)
           {
       check((t3f / 1000000)-(t3f / 10000000*10));
           }
          if((t3f / 100000)-(t3f / 1000000*10) > 0)
           {
       check((t3f / 100000)-(t3f / 1000000*10));
           }
          if((t3f / 10000)-(t3f / 100000*10) > 0)
           {
       check((t3f / 10000)-(t3f / 100000*10));
           }
          if((t3f / 1000)-(t3f / 10000*10) > 0)
           {
       check((t3f / 1000)-(t3f / 10000*10));
           }
          if((t3f / 100)-(t3f / 1000*10) > 0)
           {
       check((t3f / 100)-(t3f / 1000*10));
           }
          if((t3f / 10)-(t3f / 100*10) > 0)
           {
       check((t3f / 10)-(t3f / 100*10));
           }
          if((t3f)-(t3f / 10*10) > 0)
           {
       check((t3f)-(t3f / 10*10));
           }
         }
        
      if(t4f>0)
        {
          delay(d4);
          off();
          
          if(t4f / 10000000 > 0)
           {
       check(t4f / 10000000);
           }
          if((t4f / 1000000)-(t4f / 10000000*10) > 0)
           {
       check((t4f / 1000000)-(t4f / 10000000*10));
           }
          if((t4f / 100000)-(t4f / 1000000*10) > 0)
           {
       check((t4f / 100000)-(t4f / 1000000*10));
           }
          if((t4f / 10000)-(t4f / 100000*10) > 0)
           {
       check((t4f / 10000)-(t4f / 100000*10));
           }
          if((t4f / 1000)-(t4f / 10000*10) > 0)
           {
       check((t4f / 1000)-(t4f / 10000*10));
           }
          if((t4f / 100)-(t4f / 1000*10) > 0)
           {
       check((t4f / 100)-(t4f / 1000*10));
           }
          if((t4f / 10)-(t4f / 100*10) > 0)
           {
       check((t4f / 10)-(t4f / 100*10));
           }
          if((t4f)-(t4f / 10*10) > 0)
           {
       check((t4f)-(t4f / 10*10));
           }
         }
        
      if(t5f>0)
        {
          delay(d5);
          off();
          
          if(t5f / 10000000 > 0)
           {
       check(t5f / 10000000);
           }
          if((t5f / 1000000)-(t5f / 10000000*10) > 0)
           {
       check((t5f / 1000000)-(t5f / 10000000*10));
           }
          if((t5f / 100000)-(t5f / 1000000*10) > 0)
           {
       check((t5f / 100000)-(t5f / 1000000*10));
           }
          if((t5f / 10000)-(t5f / 100000*10) > 0)
           {
       check((t5f / 10000)-(t5f / 100000*10));
           }
          if((t5f / 1000)-(t5f / 10000*10) > 0)
           {
       check((t5f / 1000)-(t5f / 10000*10));
           }
          if((t5f / 100)-(t5f / 1000*10) > 0)
           {
       check((t5f / 100)-(t5f / 1000*10));
           }
          if((t5f / 10)-(t5f / 100*10) > 0)
           {
       check((t5f / 10)-(t5f / 100*10));
           }
          if((t5f)-(t5f / 10*10) > 0)
           {
       check((t5f)-(t5f / 10*10));
           }
         }
        
      if(t6f>0)
        {
          delay(d6);
          off();
          
          if(t6f / 10000000 > 0)
           {
       check(t6f / 10000000);
           }
          if((t6f / 1000000)-(t6f / 10000000*10) > 0)
           {
       check((t6f / 1000000)-(t6f / 10000000*10));
           }
          if((t6f / 100000)-(t6f / 1000000*10) > 0)
           {
       check((t6f / 100000)-(t6f / 1000000*10));
           }
          if((t6f / 10000)-(t6f / 100000*10) > 0)
           {
       check((t6f / 10000)-(t6f / 100000*10));
           }
          if((t6f / 1000)-(t6f / 10000*10) > 0)
           {
       check((t6f / 1000)-(t6f / 10000*10));
           }
          if((t6f / 100)-(t6f / 1000*10) > 0)
           {
       check((t6f / 100)-(t6f / 1000*10));
           }
          if((t6f / 10)-(t6f / 100*10) > 0)
           {
       check((t6f / 10)-(t6f / 100*10));
           }
          if((t6f)-(t6f / 10*10) > 0)
           {
       check((t6f)-(t6f / 10*10));
           }
         }
        
      if(t7f>0)
        {
          delay(d7);
          off();
          
          if(t7f / 10000000 > 0)
           {
       check(t7f / 10000000);
           }
          if((t7f / 1000000)-(t7f / 10000000*10) > 0)
           {
       check((t7f / 1000000)-(t7f / 10000000*10));
           }
          if((t7f / 100000)-(t7f / 1000000*10) > 0)
           {
       check((t7f / 100000)-(t7f / 1000000*10));
           }
          if((t7f / 10000)-(t7f / 100000*10) > 0)
           {
       check((t7f / 10000)-(t7f / 100000*10));
           }
          if((t7f / 1000)-(t7f / 10000*10) > 0)
           {
       check((t7f / 1000)-(t7f / 10000*10));
           }
          if((t7f / 100)-(t7f / 1000*10) > 0)
           {
       check((t7f / 100)-(t7f / 1000*10));
           }
          if((t7f / 10)-(t7f / 100*10) > 0)
           {
       check((t7f / 10)-(t7f / 100*10));
           }
          if((t7f)-(t7f / 10*10) > 0)
           {
       check((t7f)-(t7f / 10*10));
           }
         }
        
      if(t8f>0)
        {
          delay(d8);
          off();
          
          if(t8f / 10000000 > 0)
           {
       check(t8f / 10000000);
           }
          if((t8f / 1000000)-(t8f / 10000000*10) > 0)
           {
       check((t8f / 1000000)-(t8f / 10000000*10));
           }
          if((t8f / 100000)-(t8f / 1000000*10) > 0)
           {
       check((t8f / 100000)-(t8f / 1000000*10));
           }
          if((t8f / 10000)-(t8f / 100000*10) > 0)
           {
       check((t8f / 10000)-(t8f / 100000*10));
           }
          if((t8f / 1000)-(t8f / 10000*10) > 0)
           {
       check((t8f / 1000)-(t8f / 10000*10));
           }
          if((t8f / 100)-(t8f / 1000*10) > 0)
           {
       check((t8f / 100)-(t8f / 1000*10));
           }
          if((t8f / 10)-(t8f / 100*10) > 0)
           {
       check((t8f / 10)-(t8f / 100*10));
           }
          if((t8f)-(t8f / 10*10) > 0)
           {
       check((t8f)-(t8f / 10*10));
           }
        }
        delay(1000);
        off();
        MsTimer2::start();
     }
     lbutton = digitalRead(button);
    }
}

        void check(int num)      //Check to see what port is to be fired
          { 
            if(num==1)
             digitalWrite(fire1,HIGH);
            if(num==2)
             digitalWrite(fire2,HIGH);
            if(num==3)
             digitalWrite(fire3,HIGH);
            if(num==4)
             digitalWrite(fire4,HIGH);
            if(num==5)
             digitalWrite(fire5,HIGH);
            if(num==6)
             digitalWrite(fire6,HIGH);
            if(num==7)
             digitalWrite(fire7,HIGH);
            if(num==8)
             digitalWrite(fire8,HIGH);
          }

        void off()            //Turn all firing ports off
          {
            digitalWrite(fire1, LOW);
            digitalWrite(fire2, LOW);
            digitalWrite(fire3, LOW);
            digitalWrite(fire4, LOW);
            digitalWrite(fire5, LOW);
            digitalWrite(fire6, LOW);
            digitalWrite(fire7, LOW);
            digitalWrite(fire8, LOW);
          }

        void LCD()            //Update the LCD
          {
            if(upload==true)
            {
             if(load == 1)
             mySerial.print("?f");
             load = 0;
            mySerial.print("?x03?y0Upload or?x02?y1Push To Arm");
            }
            else
            {
            mySerial.print("?x02");
            mySerial.print("Push To Fire");
            }
          }


